# -*- coding: utf-8 -*-
"""typing + typing_extensions + misc types/aliases"""
import typing

import typing_extensions

from xtyping._meta import __version__
from xtyping._typing import (
    IO,
    TYPE_CHECKING,
    AbstractSet,
    Any,
    AnyStr,
    AsyncContextManager,
    AsyncGenerator,
    AsyncIterable,
    AsyncIterator,
    Awaitable,
    ByteString,
    Callable,
    ChainMap,
    ClassVar,
    Collection,
    Container,
    ContextManager,
    Coroutine,
    Counter,
    DefaultDict,
    Deque,
    Dict,
    FrozenSet,
    Generator,
    Generic,
    Hashable,
    ItemsView,
    Iterable,
    Iterator,
    KeysView,
    List,
    Mapping,
    MappingView,
    MutableMapping,
    MutableSequence,
    MutableSet,
    NamedTuple,
    NewType,
    Optional,
    Reversible,
    Sequence,
    Set,
    Sized,
    SupportsAbs,
    SupportsBytes,
    SupportsComplex,
    SupportsFloat,
    SupportsInt,
    SupportsRound,
    Text,
    Tuple,
    Type,
    TypeVar,
    Union,
    ValuesView,
    __all_typing__,
    cast,
    get_type_hints,
    no_type_check,
    no_type_check_decorator,
    overload,
)
from xtyping._typing_extensions import (
    Final,
    Literal,
    NoReturn,
    Protocol,
    TypeAlias,
    TypedDict,
    __all_typing_extensions__,
    final,
    runtime_checkable,
)
from xtyping.shed import (
    _DT,
    _R,
    _RT,
    _T,
    AF,
    DT,
    FN,
    KT,
    RT,
    STDIN,
    STDIO,
    VT,
    AnyCallable,
    AnyFunction,
    AnyIterable,
    AnyIterator,
    ArrShape,
    Bytes,
    CmdArgsType,
    Decimal,
    DictAny,
    DictFloat,
    DictInt,
    DictNumber,
    DictStr,
    DictStrAny,
    DictStrInt,
    El,
    Element,
    Enum,
    EnvMap,
    EnvType,
    F,
    Flint,
    FsPath,
    FsPathLike,
    FuncType,
    HrTime,
    IntStr,
    IterableAny,
    IterableFloat,
    IterableInt,
    IterableNumber,
    IterableStr,
    IterableT,
    JsonArrT,
    JsonDictT,
    JsonListT,
    JsonObjT,
    ListAny,
    ListFloat,
    ListInt,
    ListListStr,
    ListNumber,
    ListStr,
    ListT,
    N,
    NoneBytes,
    NoneStr,
    NoneStrBytes,
    NoneType,
    Null,
    Number,
    OptInt,
    OptionalInt,
    Path,
    PathLike,
    R,
    ReturnType,
    SetAny,
    SetFloat,
    SetInt,
    SetNumber,
    SetStr,
    SetT,
    ShapeType,
    StrBytes,
    StrEnum,
    StringEnum,
    StrIntFloat,
    T,
    T_co,
    T_contra,
    TupleStrs,
    TupleStrStr,
    Txt,
    V_co,
    VT_co,
    __all_shed__,
    null,
)


__all__ = [
    '__version__',
    'typing',
    'typing_extensions',
    'AbstractSet',
    'Any',
    'AnyStr',
    'AsyncContextManager',
    'AsyncGenerator',
    'AsyncIterable',
    'AsyncIterator',
    'Awaitable',
    'ByteString',
    'Callable',
    'ChainMap',
    'ClassVar',
    'Collection',
    'Container',
    'ContextManager',
    'Coroutine',
    'Counter',
    'DefaultDict',
    'Deque',
    'Dict',
    'FrozenSet',
    'Generator',
    'Generic',
    'Hashable',
    'IO',
    'ItemsView',
    'Iterable',
    'Iterator',
    'KeysView',
    'List',
    'Mapping',
    'MappingView',
    'MutableMapping',
    'MutableSequence',
    'MutableSet',
    'NamedTuple',
    'NewType',
    'Optional',
    'Reversible',
    'Sequence',
    'Set',
    'Sized',
    'SupportsAbs',
    'SupportsBytes',
    'SupportsComplex',
    'SupportsFloat',
    'SupportsInt',
    'SupportsRound',
    'TYPE_CHECKING',
    'Text',
    'Tuple',
    'Type',
    'TypeVar',
    'Union',
    'ValuesView',
    'cast',
    'get_type_hints',
    'no_type_check',
    'no_type_check_decorator',
    'overload',
    'final',
    'Final',
    'Literal',
    'NoReturn',
    'Protocol',
    'runtime_checkable',
    'TypedDict',
    'TypeAlias',
    'AF',
    'AnyCallable',
    'AnyFunction',
    'AnyIterable',
    'AnyIterator',
    'ArrShape',
    'Bytes',
    'CmdArgsType',
    'DT',
    'Decimal',
    'DictAny',
    'DictFloat',
    'DictInt',
    'DictNumber',
    'DictStr',
    'DictStrAny',
    'DictStrInt',
    'El',
    'Element',
    'Enum',
    'EnvMap',
    'EnvType',
    'F',
    'FN',
    'Flint',
    'FsPath',
    'FsPathLike',
    'FuncType',
    'HrTime',
    'IntStr',
    'IterableAny',
    'IterableFloat',
    'IterableInt',
    'IterableNumber',
    'IterableStr',
    'IterableT',
    'JsonArrT',
    'JsonDictT',
    'JsonListT',
    'JsonObjT',
    'KT',
    'ListAny',
    'ListFloat',
    'ListInt',
    'ListListStr',
    'ListNumber',
    'ListStr',
    'ListT',
    'N',
    'NoneBytes',
    'NoneStr',
    'NoneStrBytes',
    'NoneType',
    'Null',
    'Number',
    'OptInt',
    'OptionalInt',
    'Path',
    'PathLike',
    'R',
    'RT',
    'ReturnType',
    'STDIN',
    'STDIO',
    'SetAny',
    'SetFloat',
    'SetInt',
    'SetNumber',
    'SetStr',
    'SetT',
    'ShapeType',
    'StrBytes',
    'StrEnum',
    'StrIntFloat',
    'StringEnum',
    'T',
    'T_co',
    'T_contra',
    'TupleStrStr',
    'TupleStrs',
    'Txt',
    'VT',
    'VT_co',
    'V_co',
    '_DT',
    '_R',
    '_RT',
    '_T',
    'null',
    '__all_typing_extensions__',
    '__all_typing__',
    '__all_shed__',
]
